from PIL import Image,ImageFont,ImageDraw,ImageColor
from StringIO import StringIO
from App.Common import rfc1123_date

import time
import os

def external_mail2image(self, email = None, size = None):

    if not email:
        return

    # get options
    fonts = self.portal_properties.mail2image_properties.fonts
    lowercase = self.portal_properties.mail2image_properties.to_lowercase
    encoding = self.portal_properties.mail2image_properties.encoding
    seed = len(self.portal_properties.mail2image_properties.seed)

    if not fonts or len(fonts)<1:
        return 

    # get font options
    font = fonts[0]
    if size:
        for f in fonts:
            if f.startswith(str(size) + ','):
                font = f
                break

    font = font.split(',')
    if len(font)!=7:
        return
    font_name = font[1].strip()
    font_size = int(font[2].strip())
    font_color = font[3].strip()
    font_background = font[4].strip()
    font_offset_x = int(font[5].strip())
    font_offset_y = int(font[6].strip())

    FONT_DIR = INSTANCE_HOME + os.sep + "Products" + os.sep + "Mail2Image" + \
               os.sep + "fonts" + os.sep + font_name + ".ttf"
    font = ImageFont.truetype(FONT_DIR, font_size)

    # decrypt email string
    for c in encoding[::-1]:
        email = email.decode(c)
    email = email[::-1]
    email = email[seed:][:-seed]
  
    # lowercase 
    if lowercase:
        email = email.lower()
    
    # create image
    (width,height)=font.getsize(email)
 
    im = None
    if font_background:
        im = Image.new('RGB',(width,height),'%s' % font_background)
    else:
        im = Image.new('RGBA',(width,height),(0,0,0,0))
    draw = ImageDraw.Draw(im)
    draw.text((font_offset_x, font_offset_y), 
              email, 
              font=font , 
              fill=font_color)

    picture = StringIO()
    im.save(picture, 'png')
    picture.seek(0)

    # HTTP Cache
    if email.lower()!='test@domain.de':
        seconds = 60*60*24
        expires = rfc1123_date(time.time() + seconds)
        self.REQUEST.RESPONSE.setHeader('Last-Modified', rfc1123_date(time.time()))
        self.REQUEST.RESPONSE.setHeader('Cache-Control', 'max-age=%d' % seconds)
        self.REQUEST.RESPONSE.setHeader('Expires', expires)
    self.REQUEST.RESPONSE.setHeader('Content-Type', 'image/png')
  
    picture.seek(0)
    return picture.read()
