"""
Patches.
"""

from Products.Mail2Image.config import *

if ATDOCUMENTS_COOKEDBODY_PATCH:
    from Products.ATContentTypes.types.ATDocument import ATDocument
    from Products.CMFCore.utils import getToolByName
    from zLOG import LOG, INFO
    import re

    def CookedBody(self, stx_level=None, setlevel=0):
        text = self.getText()

        # only if installed
        qi = getToolByName(self, 'portal_quickinstaller')
        installed = [ prod['id'] for prod in qi.listInstalledProducts() ]
        if 'Mail2Image' not in installed:
            return text

        # only if mail2image_properties exists
        portal_props = getToolByName(self, 'portal_properties')
        if not hasattr(portal_props, 'mail2image_properties'):
            return text 
            
        # search emails and replace with an image + link to contact form
        def mail2image( match ):
            value = match.group()
            orig_value = value
            props = self.portal_properties.mail2image_properties
            
            # use seed
            seed = props.seed
            value = seed[::-1] + value + seed

            # reverse
            value = value[::-1]
        
            # use custom encoding + seed
            encoding = props.encoding
            for c in encoding:
                value = value.encode(c)
            
            # use links if enabled
            link_contactform = props.link_contactform
            if not link_contactform:
                return '<img src="mail2image/%s" alt="" />' % value
            link_blacklist = props.link_blacklist
            if link_blacklist:
                for lf in link_blacklist:
                    if lf and lf in orig_value:
                        return '<img src="mail2image/%s" alt="" />' % value
            link_whitelist = props.link_whitelist
            if link_whitelist:
                for lf in link_whitelist:
                    if lf and lf in orig_value:
                        out = '<a href="contact/%s" border="0">' % value
                        out += '<img src="mail2image/%s" alt="" /></a>' % value
                        return out
            return '<img src="mail2image/%s" alt="" />' % value

        p = re.compile('[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,4}')
        text = p.sub(mail2image, text)
        return text

    ATDocument.CookedBody = CookedBody
    LOG(PROJECTNAME + ': ATDOCUMENTS_COOKEDBODY_PATCH', INFO, "active")
