## Controller Script (Python) "mail2image_setProperties"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=Set Mail2Image properties
##

from Products.CMFCore.utils import getToolByName

REQUEST=context.REQUEST
portal_properties=getToolByName(context, 'portal_properties')

# test for valid encodings
encoding = REQUEST.get('encoding','').strip()
for e in encoding.split():
    try:
        u'test'.encode(e)
    except:
        state.setError('encoding', 
                       'You entered an invalid codec.', 
                       'invalid_codec')
        return state.set(status = 'failure', 
                         portal_status_message = \
                         'Please correct the indicated errors.')

# join font string 
# XXX - *args* very very ugly!!!
# there should be more fallbacks etc. pp
font0 = REQUEST.get('font0[]',[])
font1 = REQUEST.get('font1[]',[])
font2 = REQUEST.get('font2[]',[])
font3 = REQUEST.get('font3[]',[])
font4 = REQUEST.get('font4[]',[])
font5 = REQUEST.get('font5[]',[])
font6 = REQUEST.get('font6[]',[])
fontzip = zip(font0,font1,font2,font3,font4,font5,font6)
fonts = []
for f in fontzip:
    temp = '%s,%s,%s,%s,%s,%s,%s' % (f[0],f[1],f[2],f[3],f[4],f[5],f[6])
    fonts.append(temp)

# change settings
portal_properties.mail2image_properties.manage_changeProperties(
    fonts = fonts,
    to_lowercase = REQUEST.get('to_lowercase',''),
    encoding = encoding,
    seed = REQUEST.get('seed',''),
    link_contactform = REQUEST.get('link_contactform',''),
    enable_captcha = REQUEST.get('enable_captcha',''),
    link_whitelist = REQUEST.get('link_whitelist',''),
    link_blacklist = REQUEST.get('link_blacklist',''),
    subject_prefix = REQUEST.get('subject_prefix',''),
    message_template = REQUEST.get('message_template','%(message)s')
)

msg = 'Mail2Image settings updated.'

return state.set(portal_status_message=msg)
