## Controller Python Script "send_contact"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=Send email 
##
REQUEST=context.REQUEST

from Products.CMFPlone.utils import transaction_note
from Products.CMFCore.utils import getToolByName
from ZODB.POSException import ConflictError

##
## This may change depending on the called (portal_feedback or author)
state_success = "success"
state_failure = "failure"


plone_utils = getToolByName(context, 'plone_utils')
mtool = getToolByName(context, 'portal_membership')
portal_props = getToolByName(context, 'portal_properties')
mail_props = portal_props.mail2image_properties

## make these arguments?
subject = REQUEST.get('subject', '')
message = REQUEST.get('message', '')
sender_from_address = REQUEST.get('sender_from_address', '')
sender_fullname = REQUEST.get('sender_fullname', '')

email = REQUEST.get('crypted_email','')
encoding = mail_props.encoding
seed = len(mail_props.seed)
subject_prefix = mail_props.subject_prefix
message_template = mail_props.message_template

try:
    for c in encoding[::-1]:
        email = email.decode(c)
except:
    exception = context.plone_utils.exceptionString()
    message = context.translate("Unable to send mail: ${exception}",
                                {'exception': exception})
    return state.set(status=state_failure, portal_status_message=message)

email = email[::-1]
email = email[seed:][:-seed]
email = email.strip()
      
reg_tool=context.portal_registration
if not reg_tool.isValidEmail(email):
    message = context.translate("Unable to send mail: Invalid email address")
    return state.set(status=state_failure, portal_status_message=message)


send_to_address = email.encode('ascii')
envelope_from = send_to_address

state.set(status=state_success) ## until proven otherwise

host = context.MailHost # plone_utils.getMailHost() (is private)
encoding = plone_utils.getSiteEncoding()

variables = {
    'sender_from_address' : sender_from_address,
    'sender_fullname'     : sender_fullname,
    'subject'             : subject,
    'message'             : message 
}

try:
    message = message_template % variables
    result = host.secureSend(message, 
                             send_to_address, 
                             envelope_from, 
                             subject=subject_prefix + subject, 
                             subtype='plain', 
                             charset=encoding, 
                             debug=False, 
                             From=sender_from_address)
except ConflictError:
    raise
except: # TODO Too many things could possibly go wrong. So we catch all.
    exception = context.plone_utils.exceptionString()
    message = context.translate("Unable to send mail: ${exception}",
                                {'exception': exception})
    return state.set(status=state_failure, portal_status_message=message)


## clear request variables so form is cleared as well
REQUEST.set('message', None)
REQUEST.set('subject', None)
REQUEST.set('sender_from_address', None)
REQUEST.set('sender_fullname', None)
REQUEST.set('crypted_email', None)

state.set(portal_status_message='Mail sent.')
return state
